# server.py

from multiprocessing import Queue, managers
from multiprocessing.queues import Empty
import select
import threading


class RServer(object):
    def __init__(self, items_buffer):
        
        self.items_buffer = items_buffer
    
    def receive_items(self):
        while True:
            (_, [], []) = select.select([self.items_buffer._reader], [], [])
            while True:
                try:
                    item = self.items_buffer.get(block=False)
                    # do something with item
                    print('item received:', item)
                except Empty:
                    break


class SharedObjectsManager(managers.BaseManager):
    pass


if __name__ == '__main__':
    
    items_buffer = Queue()
    
    remote_server = RServer(items_buffer)
    
    SharedObjectsManager.register('items_buffer', callable=lambda: items_buffer)
    
    shared_objects_manager = SharedObjectsManager(address=('localhost', 5001),
                                                  authkey=str.encode('my_server'),
                                                  serializer='xmlrpclib')
    
    shared_objects_manager.start()
    remote_server.receive_items()
